//=============================================================================
//  MuseScore
//  Music Composition & Notation
//
//  PerfectLength Plugin
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License version 2
//  as published by the Free Software Foundation and appearing in
//  the file LICENCE.GPL
//=============================================================================

import QtQuick 2.0
import MuseScore 3.0
import QtQuick.Controls 1.0

MuseScore {
      menuPath: "Plugins.PerfectLength"
      description: "Doubles all note values."
      version: "1.0"
      requiresScore: true
      
      onRun: {
            if (typeof curScore === 'undefined')
                  {Qt.quit()}
            console.log("Current score: ")
            console.log(curScore.name)
            
            var n = curScore.nmeasures; //iterator
			 var numberOfMeasures = curScore.nmeasures;
            var curs = curScore.newCursor();

            curScore.appendMeasures(n);
			
			curs.rewind(0);
			var holdingSegment = curs.segment; //don't want to reinitialize within loop
            
            do {
			
			curs.rewind(0); //go to start of score
            for (var i=0; i<n; i++) {curs.nextMeasure();} //find measure to be copied


			for (var i=0; i<curs.measure.nsegments; i++) //for all segments in nth measure
			{

			for (var j=0; j<i; j++) {curs.next()}; //select next segment to be copied
				
			//place it properly in next measure
				//break up next measure into proper segments
					holdingSegment = curs.segment; //capture original segment to be pasted
					for(var i=0; i<numberOfMeasures; i++) {curs.nextMeasure();} //move to correct measure
					while (!(curs.segment.nextInMeasure==null)) //find last segment in measure
					{
						curs.next();
					}
				//location is now properly selected
				
				//actually place the note:
					curs.setDuration(2*holdingSegment.n,2*holdingSegment.z); //imo this function should take a fraction >:[
					for (var i=0; i<holdingSegment.Element(curs.track).notes.length; i++) //loop to copy all notes in selected chord - length is the length of the notes array
					{
						curs.addNote(holdingSegment.Element(curs.track).notes[i]); //add each note from holdingSegment.notes array to current segment
					}
			}
            
			n--
            } while (!((n-1)==-1)) //until we reach the first measure
            
            
            
            
            Qt.quit()
            }
      }
